package com.zoyinc.yankit;

import java.sql.*;
import oracle.jdbc.*;
import oracle.jdbc.pool.OracleDataSource;
import java.io.*;

public class main {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		
		String tmpWorkingDir = args[0];
		String jdbcConnectURL = "jdbc:oracle:thin:" + args[1];
		String queryStr = args[2];
		File rowDir = null;
		System.out.println("tmpWorkingDir = " + tmpWorkingDir);
		System.out.println("jdbcConnectURL = " + jdbcConnectURL);
		System.out.println("queryStr = " + queryStr);
		System.out.println("Number of arguments = " + Integer.toString( args.length));
		
		try{
			
			OracleDataSource ods = new OracleDataSource();
			ods.setURL(jdbcConnectURL);
		    Connection conn = ods.getConnection();
		    
		    // Create a statement
		    Statement stmt = conn.createStatement();

		    // Do the SQL "Hello World" thing
		    ResultSet rset = stmt.executeQuery(queryStr);
		    
		    java.sql.Blob blob = null;
		    int rowCt = 0;
		    int columnCt = 0;
		    String outputSubdir = "";
		    String datafileStr = "";
		    String currOutDirStr = "";
		    while (rset.next()){
		       
		    	rowCt ++;
		    	ResultSetMetaData rsmd = rset.getMetaData();
		    	columnCt = rsmd.getColumnCount();
		    	outputSubdir = "row_" + Integer.toString(rowCt);
		    	currOutDirStr = tmpWorkingDir + "/" + outputSubdir;
		    	
		    	System.out.println("Number of columns returned = " + Integer.toString(columnCt));
		    	
		    	// Create output directory including any missing directories
		    	System.out.println( "Creating directory: " + currOutDirStr);
		    	if ( new File( currOutDirStr ).mkdirs() ){
		    		System.out.println( "Failed to create output directory: " + currOutDirStr);
		    	}
		    	
		    	for (int i = 1; i <= columnCt; i ++){
		    		System.out.println( "Column " + Integer.toString(i) + " has type " + Integer.toString( rsmd.getColumnType(i) ) );
		    		
		    		datafileStr = currOutDirStr + "/" + rsmd.getColumnName(i);
		    		System.out.println("Output file = " + datafileStr);
		    		switch (rsmd.getColumnType(i)){
		    		
		    		   // VarChar2
		    		   case 12:   
		    			   System.out.println( "VarChar2");
		    			   
		    			   break;
		    		   
		    		   
		    		   // CLOB
		    		   case 2005: 
		    			   System.out.println( "CLOB");
		    			   break;
		    		   
		    		   // BLOB
		    		   case 2004: 
		    			   System.out.println( "BLOB");
		   		    	   blob = ((OracleResultSet)rset).getBLOB(i);
		   		    	
		   		    	   // get the length of the blob
		   		    	   // print the length of the blob
		   		    	   System.out.println("blob length = " + Long.valueOf(blob.length()) + " bytes.");
		   		    	
		   		    	   

		   		    	   
		   		    	   OutputStream out = new FileOutputStream( datafileStr + ".bin");
		   		    	   byte[] buff = blob.getBytes(1,(int)blob.length());
		   		    	   out.write(buff);
		   		    	   out.close();
		    			   break;
		    		   
		    		   // Number
		    		   case 2:	  
		    			   System.out.println( "Number");
		    			   break;
		    		}
		    	}
		    	
//		    	// System.out.println(rset.getString(1));
//		    	blob = ((OracleResultSet)rset).getBLOB(1);
//		    	
//		    	// get the length of the blob
//		    	// print the length of the blob
//		    	System.out.println("blob length = " + Long.valueOf(blob.length()) + " bytes.");
//		    	
//		    	
//		    	String name = rsmd.getColumnName(1);
//		    			 System.out.println("Column name = " + name);
//		    			 String outFileName = tmpWorkingDir + "Result_" + Integer.toString(rowCt);
//		    			 System.out.println("new ");
//		    	
//		    	//InputStream in = blob.getBinaryStream();
//		    	OutputStream out = new FileOutputStream("c:/temp/my_blob.txt");
//		    	byte[] buff = blob.getBytes(1,(int)blob.length());
//		    	out.write(buff);
//		    	out.close();
		    }
		      // close the result set, the statement and the connection
		      rset.close();
		      stmt.close();
		      conn.close();


		} catch (SQLException e) { 
		   System.err.println("SQL Exception: " + e);
		   // Return an error code other than 0
		   System.exit(1);
	    } 
		catch (FileNotFoundException e) { 
	       System.err.println("File Not Found Exception: " + e);
	       // Return an error code other than 0
	       System.exit(1);
        } catch (IOException e) { 
  	       System.err.println("I/O Exception: " + e);
  	       // Return an error code other than 0
  	       System.exit(1);
        }

	}

}
